/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs } from "igniteui-react-core";
import { ElevationHelper } from "igniteui-react-core";
import { NativeUI } from "igniteui-react-core";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { Icon } from "igniteui-react-inputs";
import { BaseDOMEventProxy } from "igniteui-react-core";
import { ExpansionPanelUtilities } from "./ExpansionPanelUtilities";
import { BrushUtil } from "igniteui-react-core";
import { OnCollapsedEventArgs } from "./OnCollapsedEventArgs";
import { OnExpandedEventArgs } from "./OnExpandedEventArgs";
import { AnimationKeyFrameProperty } from "igniteui-react-core";
import { TranslateTransform } from "igniteui-react-core";
import { stringEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
export let ExpansionPanelView = /*@__PURE__*/ (() => {
    class ExpansionPanelView extends Base {
        constructor() {
            super(...arguments);
            this.i = null;
            this.p = null;
            this.g = null;
            this.f = null;
            this.o = null;
            this.k = null;
            this.n = null;
            this.m = null;
            this.l = null;
        }
        get q() {
            return this.p;
        }
        get h() {
            return this.g;
        }
        get j() {
            return this.i;
        }
        aa() {
            this.q.setStyleProperty("display", "flex");
            this.q.setStyleProperty("flexDirection", "column");
            this.q.setStyleProperty("flexWrap", "no-wrap");
            this.q.setStyleProperty("alignItems", "left");
        }
        ai() {
            let a = this.h;
            let b = ElevationHelper.e(a.r, a.bo, a.bn, a.bj);
            this.q.setStyleProperty("box-shadow", b);
        }
        aj() {
            if (null == this.q) {
                return;
            }
            this.ai();
            this.ag();
            this.ah();
            this.af();
            if (null != this.o) {
                NativeUI.j(this.o, this.h.bm);
            }
            if (null != this.k) {
                NativeUI.n(this.k, this.h.bk);
            }
            if (null != this.n) {
                NativeUI.n(this.n, this.h.bl);
            }
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.k, 0, null, a);
        }
        b(a) {
            return new AnimationKeyFrameEffect(0, this.n, 0, null, a);
        }
        c(a) {
            return new AnimationKeyFrameEffect(0, this.o, 0, null, a);
        }
        d(a) {
            return new AnimationKeyFrameEffect(0, this.l, 0, null, a);
        }
        e(a) {
            return new AnimationKeyFrameEffect(0, this.m, 0, null, a);
        }
        u() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.j;
            }
        }
        r() {
            return this.l.outerHeight();
        }
        ab(a) {
            if (a == null) {
                this.i = null;
                return;
            }
            this.i = a;
            let b = a.rootWrapper;
            this.x(b);
        }
        af() {
            if (null == this.f) {
                return;
            }
            let a = this.h.o;
            if (a) {
                this.f.svgPath = ExpansionPanelView.s;
            }
            else {
                this.f.svgPath = ExpansionPanelView.t;
            }
        }
        ag() {
            if (null != this.k) {
                let a = this.h.ac;
                this.k.setRawText(a);
            }
        }
        ah() {
            if (null != this.n) {
                let a = this.h.ai;
                this.n.setRawText(a);
            }
        }
        x(a) {
            this.p = a;
            this.aa();
        }
        y(a) {
            this.g = a;
        }
        z() {
        }
        ae(a) {
            let b = this.j;
            this.o = a;
            let c = b.createElement("div");
            this.o.append(c);
            let d = b.createElement("div");
            d.setStyleProperty("display", "inline-block");
            d.setStyleProperty("vertical-align", "middle-block");
            let e = this.i.getSubRenderer(d);
            this.f = this.h.d();
            this.f.provideContainer(e);
            this.f.bw = ExpansionPanelView.ak;
            c.append(d);
            let f = b.createElement("div");
            f.setStyleProperty("display", "flex");
            f.setStyleProperty("flex-direction", "column");
            f.setStyleProperty("justify-content", "space-evenly");
            f.setStyleProperty("align-items", "flex-start");
            this.o.append(f);
            let g = b.createElement("div");
            f.append(g);
            this.k = b.createElement("label");
            g.append(this.k);
            let h = b.createElement("div");
            f.append(h);
            this.n = b.createElement("label");
            h.append(this.n);
            this.o.setAttribute("tabindex", "0");
            this.o.setStyleProperty("display", "flex");
            this.o.setStyleProperty("flex-direction", "row");
            c.setStyleProperty("display", "flex");
            c.setStyleProperty("justify-content", "center");
            c.setStyleProperty("flex-direction", "column");
            c.setStyleProperty("margin", "0px 10px 0px 10px");
            c.setStyleProperty("flex", "none | 0 | content");
            this.aj();
            this.o.listen("click", runOn(this, this.v));
            this.o.listen("keydown", runOn(this, this.w));
        }
        ad(a) {
            let b = this.j;
            this.m = a;
            this.m.setAttribute("tabindex", "1");
            this.m.setStyleProperty("overflow", "hidden");
        }
        ac(a) {
            let b = this.j;
            this.l = a;
        }
        v(a) {
            let b = a.originalEvent;
            let c = b.target;
            this.h.a3();
        }
        w(a) {
            let b = BaseDOMEventProxy.cu(a);
            let c = ExpansionPanelUtilities.c(a);
            switch (b) {
                case 9:
                case 3:
                    this.h.a3();
                    a.preventDefault();
                    break;
                case 17:
                    if (c == 1) {
                        this.h.av();
                        a.preventDefault();
                    }
                    break;
                case 15:
                    if (c == 1) {
                        this.h.as();
                        a.preventDefault();
                    }
                    break;
            }
        }
    }
    ExpansionPanelView.$t = /*@__PURE__*/ markType(ExpansionPanelView, 'ExpansionPanelView');
    ExpansionPanelView.ak = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    ExpansionPanelView.t = "M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z";
    ExpansionPanelView.s = "M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z";
    return ExpansionPanelView;
})();
/**
 * @hidden
 */
export let ExpansionPanel = /*@__PURE__*/ (() => {
    class ExpansionPanel extends Base {
        constructor() {
            super();
            this.c = null;
            this.onCollapsed = null;
            this.onExpanded = null;
            this.propertyChanged = null;
            this.h = null;
            this.ab = "Caption";
            this.bc = null;
            this.a5 = ExpansionPanel.bt;
            this.ba = null;
            this.bb = null;
            this.ah = stringEmpty();
            this.bf = null;
            this.a6 = ExpansionPanel.bu;
            this.bd = null;
            this.be = null;
            this.q = -1;
            this.p = ExpansionPanel.s;
            this.n = true;
            this.bg = null;
            this.a7 = ExpansionPanel.bv;
            this.bh = null;
            this.bi = null;
            this.a9 = ExpansionPanel.bx;
            this.a8 = ExpansionPanel.bw;
            this.a4 = ExpansionPanel.bs;
            let a = this.g();
            this.h = a;
            a.y(this);
        }
        ax(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.ay(a, b, c);
        }
        get ac() {
            return this.ab;
        }
        set ac(a) {
            if (a == this.ab) {
                return;
            }
            let b = this.ab;
            this.ab = a;
            this.ax("Caption", b, this.ab);
        }
        get br() {
            return this.bc;
        }
        set br(a) {
            let b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.ax("CaptionTextColor", b, a);
            }
        }
        get bk() {
            return this.a5;
        }
        set bk(a) {
            let b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.ax("ActualCaptionTextColor", b, a);
            }
        }
        get bp() {
            return this.ba;
        }
        set bp(a) {
            let b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.ax("CaptionCollapsedTextColor", b, a);
            }
        }
        get bq() {
            return this.bb;
        }
        set bq(a) {
            let b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.ax("CaptionExpandedTextColor", b, a);
            }
        }
        get ai() {
            return this.ah;
        }
        set ai(a) {
            if (a == this.ah) {
                return;
            }
            let b = this.ah;
            this.ah = a;
            this.ax("Description", b, this.ah);
        }
        get b0() {
            return this.bf;
        }
        set b0(a) {
            let b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.ax("DescriptionTextColor", b, a);
            }
        }
        get bl() {
            return this.a6;
        }
        set bl(a) {
            let b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.ax("ActualDescriptionTextColor", b, a);
            }
        }
        get by() {
            return this.bd;
        }
        set by(a) {
            let b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.ax("DescriptionCollapsedTextColor", b, a);
            }
        }
        get bz() {
            return this.be;
        }
        set bz(a) {
            let b = this.be;
            this.be = a;
            if (b != this.be) {
                this.ax("DescriptionExpandedTextColor", b, a);
            }
        }
        get t() {
            return this.q;
        }
        set t(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.ax("Elevation", b, a);
            }
        }
        get r() {
            return this.p;
        }
        set r(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.ax("ActualElevation", b, a);
            }
        }
        get o() {
            return this.n;
        }
        set o(a) {
            if (a == this.n) {
                return;
            }
            this.au();
            let b = this.n;
            this.n = a;
            let c = this.i(this.n);
            let d = this.j(this.n);
            let e = this.k(this.n);
            let f = this.l(this.n);
            let g = this.m(this.n);
            c.play();
            d.play();
            e.play();
            f.play();
            g.play();
            c.finished.f((h) => c.commitStyles());
            d.finished.f((h) => d.commitStyles());
            e.finished.f((h) => e.commitStyles());
            f.finished.f((h) => f.commitStyles());
            g.finished.f((h) => {
                g.commitStyles();
                this.ax("Expanded", b, this.n);
                if (this.n) {
                    if (this.onExpanded != null) {
                        this.onExpanded(this, new OnExpandedEventArgs());
                    }
                    else if (this.onCollapsed != null) {
                        this.onCollapsed(this, new OnCollapsedEventArgs());
                    }
                }
            });
        }
        get b7() {
            return this.bg;
        }
        set b7(a) {
            let b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.ax("HeaderBackgroundColor", b, a);
            }
        }
        get bm() {
            return this.a7;
        }
        set bm(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.ax("ActualHeaderBackgroundColor", b, a);
            }
        }
        get b8() {
            return this.bh;
        }
        set b8(a) {
            let b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.ax("HeaderCollapsedBackgroundColor", b, a);
            }
        }
        get b9() {
            return this.bi;
        }
        set b9(a) {
            let b = this.bi;
            this.bi = a;
            if (b != this.bi) {
                this.ax("HeaderExpandedBackgroundColor", b, a);
            }
        }
        get bo() {
            return this.a9;
        }
        set bo(a) {
            let b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.ax("ActualUmbraShadowColor", b, a);
            }
        }
        get bn() {
            return this.a8;
        }
        set bn(a) {
            let b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.ax("ActualPenumbraShadowColor", b, a);
            }
        }
        get bj() {
            return this.a4;
        }
        set bj(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.ax("ActualAmbientShadowColor", b, a);
            }
        }
        g() {
            return new ExpansionPanelView();
        }
        ay(a, b, c) {
            switch (a) {
                case "CaptionTextColor":
                case "CaptionExpandedTextColor":
                case "CaptionCollapsedTextColor":
                case "DescriptionTextColor":
                case "DescriptionExpandedTextColor":
                case "DescriptionCollapsedTextColor":
                case "HeaderBackgroundColor":
                case "HeaderCollapsedBackgroundColor":
                case "HeaderExpandedBackgroundColor":
                case "Expanded":
                    let d = this.bm;
                    let e = this.b5();
                    let f = this.bk;
                    let g = this.b1();
                    let h = this.bl;
                    let i = this.b3();
                    let j = (d != e) || (f != g) || (h != i);
                    if (j) {
                        this.bm = e;
                        this.bk = g;
                        this.bl = i;
                    }
                    else if (a == "Expanded") {
                        this.h.aj();
                    }
                    break;
                case "Elevation":
                    this.r = this.t == -1 ? ExpansionPanel.s : this.t;
                    break;
                case "ActualElevation":
                case "ActualHeaderBackgroundColor":
                case "ActualCaptionTextColor":
                case "ActualDescriptionTextColor":
                case "ActualUmbraShadowColor":
                case "ActualPenumbraShadowColor":
                case "ActualAmbientShadowColor":
                case "Caption":
                case "Description":
                    this.h.aj();
                    break;
            }
        }
        i(a) {
            let b = this.bk;
            let c = this.b2(a);
            let d = a ? this.b() : this.a();
            let e = this.h.a(d);
            let f = [new AnimationKeyFrameProperty(7, b)];
            let g = [new AnimationKeyFrameProperty(7, c)];
            e.m(...f);
            e.m(...g);
            return KeyFrameAnimationFactory.f.c(e);
        }
        j(a) {
            let b = this.bl;
            let c = this.b4(a);
            let d = a ? this.b() : this.a();
            let e = this.h.b(d);
            let f = [new AnimationKeyFrameProperty(7, b)];
            let g = [new AnimationKeyFrameProperty(7, c)];
            e.m(...f);
            e.m(...g);
            return KeyFrameAnimationFactory.f.c(e);
        }
        k(a) {
            let b = this.bm;
            let c = this.b6(a);
            let d = a ? this.b() : this.a();
            let e = this.h.c(d);
            let f = [new AnimationKeyFrameProperty(2, b)];
            let g = [new AnimationKeyFrameProperty(2, c)];
            e.m(...f);
            e.m(...g);
            return KeyFrameAnimationFactory.f.c(e);
        }
        l(a) {
            let b = this.h.r();
            if (b <= 0) {
                b = 500;
            }
            let c = a ? -b : 0;
            let d = a ? 0 : -b;
            let e = a ? 0 : 1;
            let f = a ? 1 : 0;
            let g = a ? this.b() : this.a();
            let h = new TranslateTransform();
            h.k = c;
            let i = new TranslateTransform();
            i.k = d;
            let j = this.h.d(g);
            let k = [new AnimationKeyFrameProperty(14, h), new AnimationKeyFrameProperty(1, e)];
            let l = [new AnimationKeyFrameProperty(14, i), new AnimationKeyFrameProperty(1, f)];
            j.m(...k);
            j.m(...l);
            return KeyFrameAnimationFactory.f.c(j);
        }
        m(a) {
            let b = this.h.r();
            if (b <= 0) {
                b = 500;
            }
            let c = a ? 0 : b;
            let d = a ? b : 0;
            let e = a ? this.b() : this.a();
            let f = this.h.e(e);
            let g = [new AnimationKeyFrameProperty(10, c)];
            let h = [new AnimationKeyFrameProperty(10, d)];
            f.m(...g);
            f.m(...h);
            return KeyFrameAnimationFactory.f.c(f);
        }
        a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 3;
            return a;
        }
        b() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 3;
            return a;
        }
        au() {
            this.h.u();
        }
        d() {
            if (null == this.c) {
                this.c = new Icon();
            }
            return this.c;
        }
        b1() {
            return this.b2(this.o);
        }
        b2(a) {
            let b;
            let c = null;
            c = a ? this.bq : this.bp;
            if (null != c) {
                b = c;
            }
            else {
                b = null != this.br ? this.br : ExpansionPanel.bt;
            }
            return b;
        }
        b3() {
            return this.b4(this.o);
        }
        b4(a) {
            let b;
            let c = null;
            c = a ? this.bz : this.by;
            if (null != c) {
                b = c;
            }
            else {
                b = null != this.b0 ? this.b0 : ExpansionPanel.bu;
            }
            return b;
        }
        b5() {
            return this.b6(this.o);
        }
        b6(a) {
            let b;
            let c = null;
            c = a ? this.b9 : this.b8;
            if (null != c) {
                b = c;
            }
            else {
                b = null != this.b7 ? this.b7 : ExpansionPanel.bv;
            }
            return b;
        }
        as() {
            this.o = false;
        }
        destroy() {
            this.provideRenderer(null);
        }
        av() {
            this.o = true;
        }
        notifySizeChanged() {
        }
        provideHeader(a) {
            this.h.ae(a);
        }
        provideContentAreaOuter(a) {
            this.h.ad(a);
        }
        provideContentAreaInner(a) {
            this.h.ac(a);
        }
        provideRenderer(a) {
            this.h.ab(a);
        }
        a3() {
            this.o = !this.o;
        }
    }
    ExpansionPanel.$t = /*@__PURE__*/ markType(ExpansionPanel, 'ExpansionPanel', Base.$, [INotifyPropertyChanged_$type]);
    ExpansionPanel.bt = /*@__PURE__*/ BrushUtil.g(188, 0, 0, 0);
    ExpansionPanel.bu = /*@__PURE__*/ BrushUtil.g(188, 0, 0, 0);
    ExpansionPanel.s = 2;
    ExpansionPanel.bv = /*@__PURE__*/ BrushUtil.g(255, 245, 245, 245);
    ExpansionPanel.bx = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    ExpansionPanel.bw = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    ExpansionPanel.bs = /*@__PURE__*/ BrushUtil.g(20, 0, 0, 0);
    return ExpansionPanel;
})();
//# sourceMappingURL=ExpansionPanelView_combined.js.map
